<!-- Latest compiled and minified CSS -->
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
<div class="card bg-light">
  <div class="card-header">{{titulo}}: {{factura.descripcion}}</div>
  <div class="card-body">
    <h4 class="card-title">
      <a [routerLink]="['/clientes']" class="btn btn-light btn-xs">&laquo; volver</a>
    </h4>

    <form #facturaForm="ngForm">
      <div class="form-group row" *ngIf="factura.cliente">
        <label for="cliente" class="col-sm-2 col-form-label">Cliente</label>
        <div class="col-sm-6">
          <input type="text" name="cliente" value="{{factura.cliente.nombre}} {{factura.cliente.apellido}}" class="form-control" disabled>
        </div>
      </div>

      <div class="form-group row">
        <label for="descripcion" class="col-sm-2 col-form-label">Descripción</label>
        <div class="col-sm-6">
          <input type="text" name="descripcion" [(ngModel)]="factura.descripcion" class="form-control" required #descripcion="ngModel">
          <div class="alert alert-danger" *ngIf="descripcion.invalid && descripcion.touched || descripcion.invalid && facturaForm.submitted">
            La descripción es requerida.
          </div>
        </div>
      </div>

      <div class="form-group row">
        <label for="observacion" class="col-sm-2 col-form-label">Observación</label>
        <div class="col-sm-6">
          <textarea name="observacion" [(ngModel)]="factura.observacion" class="form-control"></textarea>
        </div>
      </div>

      <div class="form-group row">
        <div class="col-sm-6">
          <mat-form-field>
            <input type="text" placeholder="Añadir producto" aria-label="Productos" matInput [formControl]="autocompleteControl" [matAutocomplete]="auto">
            <mat-autocomplete #auto="matAutocomplete" [displayWith]="mostrarNombre" (optionSelected)="seleccionarProducto($event)">
              <mat-option *ngFor="let producto of productosFiltrados | async" [value]="producto">
                {{producto.nombre}}
              </mat-option>
            </mat-autocomplete>
          </mat-form-field>
          <div class="alert alert-danger" *ngIf="autocompleteControl.invalid && facturaForm.submitted">
            La factura no puede no tener líneas!.
          </div>
        </div>
      </div>
      <div class="alert alert-info my-4" *ngIf="factura.items.length == 0">
        No hay líneas asignadas para la factura. Debe agregar al menos una!
      </div>
      <table class="table table-striped table-hover table-sm" *ngIf="factura.items.length > 0">
        <thead>
          <tr>
            <th>Producto</th>
            <th>Precio</th>
            <th>Cantidad</th>
            <th>Total</th>
            <th>Eliminar</th>
          </tr>
        </thead>
        <tbody>
          <tr *ngFor="let item of factura.items">
            <td>{{item.producto.nombre}}</td>
            <td>{{item.producto.precio}}</td>
            <td><input type="number" value="{{item.cantidad}}" class="form-control col-sm-4" (change)="actualizarCantidad(item.producto.id, $event)"></td>
            <td>{{item.calcularImporte()}}</td>
            <td><button class="btn btn-danger btn-sm" type="button"
              (click)="eliminarItemFactura(item.producto.id)">x</button></td>
          </tr>
        </tbody>
      </table>
      <h3 class="float-right" *ngIf="factura.items.length > 0">Gran Total: <span class="badge badge-secondary">{{factura.calcularGranTotal()}}</span></h3>

      <div class="form-group row">
        <div class="col-sm-6">
          <input type="submit" (click)="create(facturaForm)" value="Crear Factura" class="btn btn-secondary">
        </div>
      </div>
    </form>

  </div>
</div>

<!-- Tarea  268 -->
  <!-- Linea 1: Crear formulario factura -->
  <!-- Linea 2: Importar librerias Mat en el app.module -->
